#include <SoftwareSerial.h>
//#include <LiquidCrystal.h>
//LiquidCristal lcd(1,2,4,5,6,7);

SoftwareSerial ArduinoUno(3,2);
int buzzerPin = 11;
int moistureSenzorPin = A0;
int waterLevelPin = A1;
int waterPumpPin = 4;
int buzzerFrequencyTone = 450;

const int dry = 1020;
const int wet = 490; // senzor in full water
const int mediumWet = 625; // senzor in medium water
const int lowWet = 738; // senzor in 1cm of water
const int justTouchingWet = 832; // senzor just touching water

const int zeroWaterLevel = 4;
const int lowWaterLevel = 230;
const int mediumWaterLevel = 450;
const int highWaterLevel = 512;

const int minHumidityPercentage = 25;
const int minWaterLevelPercentage = 25;

void setup() {
  // put your setup code here, to run once:
  pinMode(waterPumpPin,OUTPUT);
  Serial.begin(9600);
  ArduinoUno.begin(4800);
  //lcd.begin(16,2);
  delay(2000);
} 

void loop() {
  // put your main code here, to run repeatedly:
  int moistureSenzorVal = analogRead(moistureSenzorPin);
  int waterLevelVal = analogRead(waterLevelPin);
  int percentageHumidity = map(moistureSenzorVal, wet, dry, 100, 0);
  int percentageWaterLevel = map(waterLevelVal, highWaterLevel, zeroWaterLevel, 100, 0);
  
  Serial.print("Humidity ");
  Serial.print(percentageHumidity);
  Serial.println("%");

  Serial.print("WaterLevel Percentage ");
  Serial.print(percentageWaterLevel);
  Serial.println("%");

  if (percentageWaterLevel < minWaterLevelPercentage) {
    tone(buzzerPin, buzzerFrequencyTone);
    delay(1000);
    noTone(buzzerPin);
    delay(1000);
  }

  if ((percentageHumidity < minHumidityPercentage) && (percentageWaterLevel > minWaterLevelPercentage)) {
    digitalWrite(waterPumpPin, HIGH);
  } else {
    digitalWrite(waterPumpPin, LOW);
  }

  while(ArduinoUno.available()>0){
    float commandPumpFromWifi = ArduinoUno.parseFloat();
    
    if(ArduinoUno.read()== '\n'){
      if (commandPumpFromWifi == 1) {
        Serial.println("Pump turned ON by WIFI");
        for (int i = 0; i < 3; i++) {
          digitalWrite(waterPumpPin, HIGH);
          delay(1000);
        } 
      }
      if (commandPumpFromWifi == -1) {
        Serial.println("Pump turned OFF by WIFI");
        for (int i = 0; i < 3; i++) {
          digitalWrite(waterPumpPin, LOW);
          delay(1000);
        }
      }
    }
  }
   //lcd.print("Humidity"); // Prints "Humidity"
   //lcd.setCursor(0,1);
   //lcd.print(percetangeHumidity);
   //delay(3000);
   //lcd.clear();
   delay(1000);
}
