#include <ESP8266WiFi.h>
#include <SoftwareSerial.h>
SoftwareSerial NodeMCU(D2,D3);
 
const char* ssid = "Party";
const char* password = "pitesti123";
 
WiFiServer server(80);
 
void setup() {
  Serial.begin(9600);
  delay(10);
  
  NodeMCU.begin(4800);
  pinMode(D2,INPUT);
  pinMode(D3,OUTPUT);
  delay(10);
 
  // Connect to WiFi network
  Serial.println();
  Serial.println();
  Serial.print("Connecting to ");
  Serial.println(ssid);
 
  WiFi.begin(ssid, password);
 
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println("");
  Serial.println("WiFi connected");
 
  // Start the server
  server.begin();
  Serial.println("Server started");
 
  // Print the IP address
  Serial.print("Use this URL to connect: ");
  Serial.print("http://");
  Serial.print(WiFi.localIP());
  Serial.println("/");
}
 
void loop() {
  // Check if a client has connected
  WiFiClient client = server.available();
  if (!client) {
    return;
  }
 
  // Wait until the client sends some data
  Serial.println("new client");
  while(!client.available()){
    delay(1);
  }
 
  // Read the first line of the request
  String request = client.readStringUntil('\r');
  Serial.println(request);
  client.flush();
 
  // Match the request
  int value = LOW;
  if (request.indexOf("/waterPump=ON") != -1)  {
    value = HIGH;
    int turnWaterPumpOn = 1;
    NodeMCU.print(turnWaterPumpOn);
    NodeMCU.println("\n");
  }
  
  if (request.indexOf("/waterPump=OFF") != -1)  {
    value = LOW;
    int turnWaterPumpOff = -1;
    NodeMCU.print(turnWaterPumpOff);
    NodeMCU.println("\n");
  }

  // Return the response
  client.println("HTTP/1.1 200 OK");
  client.println("Content-Type: text/html");
  client.println("");
  client.println("<!DOCTYPE HTML>");
  client.println("<html>");
 
  client.print("Water Pump is now: ");
  if(value == HIGH) {
    client.print("On");
  } else {
    client.print("Off");
  }
  
  client.println("<br><br>");
  client.println("<a href=\"/waterPump=ON\"\"><button>Turn On </button></a>");
  client.println("<a href=\"/waterPump=OFF\"\"><button>Turn Off </button></a><br />");  
  client.println("</html>");
 
  delay(1);
  Serial.println("Client disonnected");
  Serial.println("");
}
